package xyz.veronie.bgg.result;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Predicate;

public enum ThingProvider {
	INSTANCE;
	
	private List<ThingMetaData> thingMetas;
	
	private ThingProvider() {
		thingMetas = new ArrayList<ThingMetaData>();
	}
	
	public void replaceThingMetas(ArrayList<ThingMetaData> metas) {
		this.thingMetas = metas;
	}
	
	public void addThingMetas(ArrayList<ThingMetaData> metas) {
		this.thingMetas.addAll(metas);
	}
	
	
	
	public static Predicate<ThingMetaData> thingEqual(ThingMetaData other) 
	{
	    return p -> p.getId() == other.getId();
	}
	
	public void subtractThingMetas(ArrayList<ThingMetaData> metas) {
		for(ThingMetaData tmd : metas) {
			this.thingMetas.removeIf(thingEqual(tmd));
		}
	}

	
	public void intersectThingMetas(ArrayList<ThingMetaData> metas) {
		List<ThingMetaData> cpMetas = new ArrayList<ThingMetaData>(this.thingMetas);
		this.thingMetas.clear();
		for(ThingMetaData tmd : metas) {
			for(ThingMetaData thisTmd : cpMetas) {
				if(tmd.getId() == thisTmd.getId()) {
					this.thingMetas.add(tmd);
				}
			}
		}
	}
	
	
	public List<ThingMetaData> getThingMetas() {
        return thingMetas;
    }
}
